package com.rjconsultores.ventaboletos.web.gui.controladores.tarifas;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Messagebox;

import com.rjconsultores.ventaboletos.constantes.Constantes;
import com.rjconsultores.ventaboletos.entidad.OrgaoConcedente;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.service.CalcularPeajeService;
import com.rjconsultores.ventaboletos.service.OrgaoConcedenteService;
import com.rjconsultores.ventaboletos.service.RutaService;
import com.rjconsultores.ventaboletos.service.TramoService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;

@Controller("calcularPeajeController")
@Scope("prototype")
public class CalcularPeajeController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;

	@Autowired
	private OrgaoConcedenteService orgaoConcedenteService;
	@Autowired
	private RutaService rutaService;
	@Autowired
	private TramoService tramoService;
	@Autowired
	private CalcularPeajeService calcularPeajeService;

	private List<OrgaoConcedente> lsOrgaoConcedente;

	private Combobox cmbOrgaoConcedente;

	public List<OrgaoConcedente> getLsOrgaoConcedente() {
		return lsOrgaoConcedente;
	}

	public void setLsOrgaoConcedente(List<OrgaoConcedente> lsOrgaoConcedente) {
		this.lsOrgaoConcedente = lsOrgaoConcedente;
	}

	public Combobox getCmbOrgaoConcedente() {
		return cmbOrgaoConcedente;
	}

	public void setCmbOrgaoConcedente(Combobox cmbOrgaoConcedente) {
		this.cmbOrgaoConcedente = cmbOrgaoConcedente;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		lsOrgaoConcedente = new ArrayList<OrgaoConcedente>();
		
		for (Integer orgaoConcedenteId : Constantes.ORGAOS_CONCEDENTES_CALCULO_ANTT) {
			lsOrgaoConcedente.add(orgaoConcedenteService.obtenerID(orgaoConcedenteId));
		}
		for (Integer orgaoConcedenteId : Constantes.ORGAOS_CONCEDENTES_CALCULO_ARTESP) {
			lsOrgaoConcedente.add(orgaoConcedenteService.obtenerID(orgaoConcedenteId));
		}

	}

	public void onClick$btnCalcularPeaje(Event ev) throws InterruptedException {
		try{
			OrgaoConcedente orgao = ((OrgaoConcedente) cmbOrgaoConcedente.getSelectedItem().getValue());
			orgao = orgaoConcedenteService.obtenerID(orgao.getOrgaoConcedenteId());
			//buscar todas as linhas de um determinado orgao acima
			if(null == orgao){return;}
			List<Ruta> lsRuta = rutaService.buscaRutasFromOrgao(orgao);
			int[] retorno = calcularPeajeService.gerarSQLInserirPeajes(lsRuta, orgao);
			
			if( retorno != null && retorno.length > 0 && retorno[0]==-1 ){
				Messagebox.show(Labels.getLabel("calcularPeajeController.MSG.rutaSemQtdAsientosOuEixo", new Object[] { ""+retorno[1]  }),
						Labels.getLabel("indexController.mniCalculoPeaje.label"),
						Messagebox.OK, Messagebox.INFORMATION);
				
			}else if( retorno != null && retorno.length > 0 && retorno[0]==-2 ){
				Messagebox.show(Labels.getLabel("calcularPeajeController.MSG.orgaoSemIndice", new Object[] { ""+retorno[1]  }),
						Labels.getLabel("indexController.mniCalculoPeaje.label"),
						Messagebox.OK, Messagebox.INFORMATION);
			}else if( retorno != null && retorno.length > 0 && retorno[0]==-3 ){
				Messagebox.show(Labels.getLabel("calcularPeajeController.MSG.rutaSemQtdEixo", new Object[] { ""+retorno[1]  }),
						Labels.getLabel("indexController.mniCalculoPeaje.label"),
						Messagebox.OK, Messagebox.INFORMATION);
			}else{
				Messagebox.show(Labels.getLabel("calcularPeajeController.MSG.suscribirOK"),
						Labels.getLabel("indexController.mniCalculoPeaje.label"),
						Messagebox.OK, Messagebox.INFORMATION);
			}
			
			
			
		}catch(NullPointerException e){
			return;
		}
		
		
	}

	

	
	
}
